unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Buttons, StdCtrls, ExtCtrls, AIOUSB;

type
  TForm1 = class(TForm)
    readTimer: TTimer;
    StartSpeedMeasurement: TButton;
    Label23: TLabel;
    labDuration: TLabel;
    butAbort: TButton;
    Label1: TLabel;
    procedure StartSpeedMeasurementClick(Sender: TObject);
    procedure readTimerTimer(Sender: TObject);
    procedure butAbortClick(Sender: TObject);
  private
    { Private declarations }
    StartTime: TDateTime;
    secondsRunning: integer;
    oldValue: word;
  public
    { Public declarations }
  end;



var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.readTimerTimer(Sender: TObject);
  var
    Value, Status: Word;
    CTRStatus: Byte;
begin
  Status := CTR_8254ReadStatus(diOnly, 0, 0, @Value, @CTRStatus);
  if Status = 0 then
    if Value <> 0 then
      if OldValue <> Value then
      begin
        labDuration.Caption := Format('%.1fs',[((65536-Value) / 10)]);
        OldValue := Value;
      end
      else
      begin
        label1.Caption := 'DONE: '+labDuration.Caption;
        readTimer.Enabled := False;
        StartSpeedMeasurement.Caption := 'Click here to arm speed measurement';
        butAbort.Visible := False;
      end
  ;

  if Now > StartTime + 1/24/60/60 then
  begin
    inc(secondsRunning);
    label1.caption := 'ARMED: waiting for ' + IntToStr(secondsRunning) + ' seconds.';
    startTime := Now;
  end;


end;

procedure TForm1.StartSpeedMeasurementClick(Sender: TObject);
begin
  StartSpeedMeasurement.Caption := 'ARMED: Waiting for signal';
  butAbort.Visible := True;
  labDuration.Caption := '---s';
  CTR_8254ModeLoad(diOnly, 0, 0, 2, 0);
  StartTime:=Now;
  secondsRunning := 0;
  label1.caption := 'Status: Armed.';
  oldValue := 0;
  readTimer.Enabled := True;
end;

procedure TForm1.butAbortClick(Sender: TObject);
begin
  readTimer.Enabled := False;
          labDuration.Caption := format('---s',[-1]);
          readTimer.Enabled := False;
          StartSpeedMeasurement.Caption := 'Click here to arm speed measurement';
          butAbort.Visible := False;
          label1.caption := 'Status: Aborted.';
end;

end.
